Gentoo Archives: gentoo-commits

From: Emil Karlson <jekarlson@×××××.com>
To: gentoo-commits@l.g.o
Subject: [gentoo-commits] proj/x11:master commit in: x11-drivers/ati-drivers/
Date: Wed, 26 Mar 2014 05:41:00
Message-Id: 1395812449.3e594905ea4fce9c4327dee6dbb7db16d23d0814.emil_karlson@gentoo
1 commit: 3e594905ea4fce9c4327dee6dbb7db16d23d0814
2 Author: Emil Karlson <jekarlson <AT> gmail <DOT> com>
3 AuthorDate: Wed Mar 26 05:40:49 2014 +0000
4 Commit: Emil Karlson <jekarlson <AT> gmail <DOT> com>
5 CommitDate: Wed Mar 26 05:40:49 2014 +0000
6 URL: http://git.overlays.gentoo.org/gitweb/?p=proj/x11.git;a=commit;h=3e594905
7
8 x11-drivers/ati-drivers: beta version bump
9
10 ---
11 ...rs-13.1.ebuild => ati-drivers-14.3_beta.ebuild} | 140 ++++++++++++---------
12 1 file changed, 84 insertions(+), 56 deletions(-)
13
14 diff --git a/x11-drivers/ati-drivers/ati-drivers-13.1.ebuild b/x11-drivers/ati-drivers/ati-drivers-14.3_beta.ebuild
15 similarity index 82%
16 rename from x11-drivers/ati-drivers/ati-drivers-13.1.ebuild
17 rename to x11-drivers/ati-drivers/ati-drivers-14.3_beta.ebuild
18 index 138e3b0..92b54d9 100644
19 --- a/x11-drivers/ati-drivers/ati-drivers-13.1.ebuild
20 +++ b/x11-drivers/ati-drivers/ati-drivers-14.3_beta.ebuild
21 @@ -4,30 +4,27 @@
22
23 EAPI=5
24
25 -inherit eutils multilib linux-info linux-mod toolchain-funcs versionator
26 +inherit eutils multilib linux-info linux-mod toolchain-funcs versionator pax-utils
27
28 DESCRIPTION="Ati precompiled drivers for Radeon Evergreen (HD5000 Series) and newer chipsets"
29 HOMEPAGE="http://www.amd.com"
30 -MY_V=( $(get_version_components) )
31 -#RUN="${WORKDIR}/amd-driver-installer-9.00-x86.x86_64.run"
32 +RUN="${WORKDIR}/fglrx-13.35.1005/amd-driver-installer-13.35.1005-x86.x86_64.run"
33 SLOT="1"
34 -if [[ legacy != ${SLOT} ]]; then
35 - DRIVERS_URI="http://www2.ati.com/drivers/linux/amd-driver-installer-catalyst-${PV}-linux-x86.x86_64.zip"
36 -else
37 - DRIVERS_URI="http://www2.ati.com/drivers/legacy/amd-driver-installer-catalyst-$(get_version_component_range 1-2)-legacy-linux-x86.x86_64.zip"
38 -fi
39 +# Uses javascript for download YESSSS
40 +#DRIVERS_URI="http://www2.ati.com/drivers/linux/amd-catalyst-13.12-linux-x86.x86_64.zip"
41 +DRIVERS_URI="http://dev.gentooexperimental.org/~scarabeus/Linux_AMD_Catalyst_14.3_Beta_V1.0_B22_March12_2014.zip"
42 XVBA_SDK_URI="http://developer.amd.com/wordpress/media/2012/10/xvba-sdk-0.74-404001.tar.gz"
43 SRC_URI="${DRIVERS_URI} ${XVBA_SDK_URI}"
44 FOLDER_PREFIX="common/"
45 -IUSE="debug +modules multilib qt4 static-libs disable-watermark pax_kernel"
46 +IUSE="debug +modules multilib qt4 static-libs pax_kernel"
47
48 LICENSE="AMD GPL-2 QPL-1.0"
49 KEYWORDS="-* ~amd64 ~x86"
50
51 -RESTRICT="bindist test"
52 +RESTRICT="bindist test fetch"
53
54 RDEPEND="
55 - <=x11-base/xorg-server-1.13.49[-minimal]
56 + <=x11-base/xorg-server-1.15.49[-minimal]
57 >=app-admin/eselect-opengl-1.0.7
58 app-admin/eselect-opencl
59 sys-power/acpid
60 @@ -40,7 +37,16 @@ RDEPEND="
61 virtual/glu
62 multilib? (
63 app-emulation/emul-linux-x86-opengl
64 - app-emulation/emul-linux-x86-xlibs
65 + || (
66 + (
67 + x11-libs/libX11[abi_x86_32]
68 + x11-libs/libXext[abi_x86_32]
69 + x11-libs/libXinerama[abi_x86_32]
70 + x11-libs/libXrandr[abi_x86_32]
71 + x11-libs/libXrender[abi_x86_32]
72 + )
73 + app-emulation/emul-linux-x86-xlibs
74 + )
75 )
76 qt4? (
77 x11-libs/libICE
78 @@ -104,6 +110,8 @@ QA_PRESTRIPPED="
79 usr/lib\(32\|64\)\?/libAMDXvBA.so.1.0
80 usr/lib\(32\|64\)\?/libaticaldd.so
81 usr/lib\(32\|64\)\?/dri/fglrx_dri.so
82 + usr/lib\(32\|64\)\?/OpenCL/vendors/amd/libOpenCL.so.1
83 + usr/lib\(32\|64\)\?/OpenCL/vendors/amd/libamdocl\(32\|64\).so
84 "
85
86 QA_SONAME="
87 @@ -144,33 +152,47 @@ QA_DT_HASH="
88 usr/lib\(32\|64\)\?/OpenCL/vendors/amd/libOpenCL.so.1
89 "
90
91 -CONFIG_CHECK="~MTRR ~!DRM ACPI PCI_MSI !LOCKDEP"
92 -use amd64 && CONFIG_CHECK="${CONFIG_CHECK} COMPAT"
93 -ERROR_MTRR="CONFIG_MTRR required for direct rendering."
94 -ERROR_DRM="CONFIG_DRM must be disabled or compiled as a module for direct
95 - rendering."
96 -ERROR_LOCKDEP="CONFIG_LOCKDEP (lock tracking) exports the symbol lock_acquire
97 - as GPL-only. This prevents ${P} from compiling with an error like this:
98 - FATAL: modpost: GPL-incompatible module fglrx.ko uses GPL-only symbol 'lock_acquire'"
99 -
100 -_check_kernel_config() {
101 - if ! linux_chkconfig_present AGP && \
102 - ! linux_chkconfig_present PCIEPORTBUS; then
103 - ewarn "You don't have AGP and/or PCIe support enabled in the kernel"
104 - ewarn "Direct rendering will not work."
105 - fi
106 +pkg_nofetch() {
107 + einfo "The driver package"
108 + einfo "Linux_AMD_Catalyst_14.3_Beta_V1.0_B22_March12_2014.zip"
109 + einfo "needs to be downloaded manually from"
110 + einfo "http://support.amd.com/en-us/download/desktop?os=Linux%20x86_64"
111
112 - kernel_is ge 2 6 37 && kernel_is le 2 6 38 && if ! linux_chkconfig_present BKL ; then
113 - die "CONFIG_BKL must be enabled for kernels 2.6.37-2.6.38."
114 - fi
115 }
116
117 pkg_pretend() {
118 + local CONFIG_CHECK="~MTRR ~!DRM ACPI PCI_MSI !LOCKDEP !PAX_KERNEXEC_PLUGIN_METHOD_OR"
119 + use amd64 && CONFIG_CHECK+=" COMPAT"
120 +
121 + local ERROR_MTRR="CONFIG_MTRR required for direct rendering."
122 + local ERROR_DRM="CONFIG_DRM must be disabled or compiled as a module and not loaded for direct
123 + rendering to work."
124 + local ERROR_LOCKDEP="CONFIG_LOCKDEP (lock tracking) exports the symbol lock_acquire
125 + as GPL-only. This prevents ${P} from compiling with an error like this:
126 + FATAL: modpost: GPL-incompatible module fglrx.ko uses GPL-only symbol 'lock_acquire'"
127 + local ERROR_PAX_KERNEXEC_PLUGIN_METHOD_OR="This config option will cause
128 + kernel to reject loading the fglrx module with
129 + \"ERROR: could not insert 'fglrx': Exec format error.\"
130 + You may want to try CONFIG_PAX_KERNEXEC_PLUGIN_METHOD_BTS instead."
131 + local ERROR_BKL="CONFIG_BKL must be enabled for kernels 2.6.37-2.6.38."
132 +
133 # workaround until bug 365543 is solved
134 if use modules; then
135 linux-info_pkg_setup
136 require_configured_kernel
137 - _check_kernel_config
138 + kernel_is ge 2 6 37 && kernel_is le 2 6 38 && CONFIG_CHECK+=" BKL"
139 + check_extra_config
140 + if ! linux_chkconfig_present AGP && \
141 + ! linux_chkconfig_present PCIEPORTBUS; then
142 + ewarn "You don't have AGP and/or PCIe support enabled in the kernel"
143 + ewarn "Direct rendering will not work."
144 + fi
145 + fi
146 +
147 + if ! has XT ${PAX_MARKINGS} && use pax_kernel; then
148 + ewarn "You have disabled xattr pax markings for portage."
149 + ewarn "This will likely cause programs using ati-drivers provided"
150 + ewarn "libraries to be killed kernel."
151 fi
152 }
153
154 @@ -229,12 +251,16 @@ src_unpack() {
155 else
156 RUN="${DISTDIR}/${DRIVERS_DISTFILE}"
157 fi
158 - sh ${RUN} --extract "${S}" 2>&1 > /dev/null || die
159 + sh "${RUN}" --extract "${S}" 2>&1 > /dev/null || die
160 fi
161
162 mkdir xvba_sdk
163 cd xvba_sdk
164 unpack ${XVBA_SDK_DISTFILE}
165 +
166 + mkdir -p "${WORKDIR}/extra" || die "mkdir extra failed"
167 + cd "${WORKDIR}/extra"
168 + tar -xf "../${FOLDER_PREFIX}usr/src/ati/fglrx_sample_source.tgz"
169 }
170
171 src_prepare() {
172 @@ -275,16 +301,24 @@ src_prepare() {
173 # first hunk applied upstream second (x32 related) was not
174 epatch "${FILESDIR}"/ati-drivers-x32_something_something.patch
175
176 - # compile fix for linux-3.7
177 - # https://bugs.gentoo.org/show_bug.cgi?id=438516
178 - epatch "${FILESDIR}/ati-drivers-vm-reserverd.patch"
179 -
180 # compile fix for AGP-less kernel, bug #435322
181 epatch "${FILESDIR}"/ati-drivers-12.9-KCL_AGP_FindCapsRegisters-stub.patch
182
183 - # Use ACPI_DEVICE_HANDLE wrapper to make driver build on linux-3.8
184 - # see https://bugs.gentoo.org/show_bug.cgi?id=448216
185 - epatch "${FILESDIR}/ati-drivers-kernel-3.8-acpihandle.patch"
186 + # Compile fix for kernel typesafe uid types #469160
187 + epatch "${FILESDIR}/typesafe-kuid.diff"
188 +
189 + epatch "${FILESDIR}/ati-drivers-13.8-beta-include-seq_file.patch"
190 +
191 + epatch "${FILESDIR}/check-for-iommu-only-if-iommu-is-supported.patch"
192 +
193 + # Fix #483400
194 + epatch "${FILESDIR}/fgl_glxgears-do-not-include-glATI.patch"
195 +
196 + # Fix build on new kernels
197 + #epatch "${FILESDIR}/ati-drivers-13.12-acpi.patch"
198 +
199 + # Add support for linux-3.13. See #498766
200 + #epatch "${FILESDIR}/ati-drivers-linux-3.13-acpi-handle.patch"
201
202 # Compile fix, https://bugs.gentoo.org/show_bug.cgi?id=454870
203 use pax_kernel && epatch "${FILESDIR}/const-notifier-block.patch"
204 @@ -304,22 +338,6 @@ src_prepare() {
205 sed -i -e 's/__SMP__/CONFIG_SMP/' *.c *h || die "SMP sed failed"
206 sed -i -e 's/ifdef MODVERSIONS/ifdef CONFIG_MODVERSIONS/' *.c *.h \
207 || die "MODVERSIONS sed failed"
208 - cd "${S}"
209 -
210 - mkdir extra || die "mkdir extra failed"
211 - cd extra
212 - unpack ./../${FOLDER_PREFIX}usr/src/ati/fglrx_sample_source.tgz
213 -
214 - # Get rid of watermark. Oldest known reference:
215 - # http://phoronix.com/forums/showthread.php?19875-Unsupported-Hardware-watermark
216 - if use disable-watermark; then
217 - ebegin "Disabling watermark"
218 - driver="${MY_BASE_DIR}"/usr/X11R6/${PKG_LIBDIR}/modules/drivers/fglrx_drv.so
219 - for x in $(objdump -d ${driver}|awk '/call/&&/EnableLogo/{print "\\x"$2"\\x"$3"\\x"$4"\\x"$5"\\x"$6}'); do
220 - sed -i "s/${x/x5b/\x5b}/\x90\x90\x90\x90\x90/g" ${driver} || break 1
221 - done
222 - eend $? || die "Disabling watermark failed"
223 - fi
224 }
225
226 src_compile() {
227 @@ -412,7 +430,7 @@ src_install() {
228 insinto /etc/ati
229 exeinto /etc/ati
230 # Everything except for the authatieventsd.sh script.
231 - doins ${FOLDER_PREFIX}etc/ati/{logo*,control,atiogl.xml,signature,amdpcsdb.default}
232 + doins ${FOLDER_PREFIX}etc/ati/{logo*,control,signature,amdpcsdb.default}
233 doexe ${FOLDER_PREFIX}etc/ati/authatieventsd.sh
234
235 # include.
236 @@ -549,6 +567,10 @@ src_install-libs() {
237
238 #install xvba sdk headers
239 doheader xvba_sdk/include/amdxvba.h
240 +
241 + if use pax_kernel; then
242 + pax-mark m "${D}"/usr/lib*/opengl/ati/lib/libGL.so.1.2 || die "pax-mark failed"
243 + fi
244 }
245
246 pkg_postinst() {
247 @@ -578,6 +600,12 @@ pkg_postinst() {
248 ewarn "try disabling sna for xf86-video-intel."
249 ewarn "For details, see https://bugs.gentoo.org/show_bug.cgi?id=430000"
250 fi
251 +
252 + if use pax_kernel; then
253 + ewarn "Please run \"revdep-pax -s libGL.so.1 -me\" after installation and"
254 + ewarn "after you have run \"eselect opengl set ati\". Executacle"
255 + ewarn "revdep-pax is part of package sys-apps/elfix."
256 + fi
257 }
258
259 pkg_preinst() {